## ros-melodic-psen-scan-v2 0.1.2

=== CMakeLists.txt ===
# Copyright (c) 2020 Pilz GmbH & Co. KG
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 2.8.12)
project(psen_scan_v2)

add_compile_options(-std=c++14)
add_compile_options(-Wall)
add_compile_options(-Wextra)
add_compile_options(-Wno-unused-parameter)
add_compile_options(-Werror)

find_package(catkin REQUIRED COMPONENTS
  rosconsole_bridge
  roscpp
  sensor_msgs
  rosfmt
)

## System dependencies are found with CMake's conventions
find_package(Boost REQUIRED COMPONENTS system)

find_package(console_bridge REQUIRED)

catkin_package(
  CATKIN_DEPENDS
    rosconsole_bridge
    roscpp
    sensor_msgs
  DEPENDS
    console_bridge
)


###############
## Sanitizer ##
###############
# to run (only one sanitizer at a time):
# 1. Set environment variables for log_path in your shell
# export ASAN_OPTIONS="log_path=/path/to/asan-logs"
# export TSAN_OPTIONS="log_path=/path/to/tsan-logs"
# export UBSAN_OPTIONS="log_path=/path/to/ubsan-logs"
# 2. Compile
# catkin_make -DCATKIN_SANITIZER=address|thread|undefined
# 3. Run the node
# 4. Check log_path folder for contents
# build and devel folders have to be deleted before run
if(CATKIN_SANITIZER)
  set(SANITIZER_OPTIONS "address|thread|undefined")
  if("${CATKIN_SANITIZER}" MATCHES "${SANITIZER_OPTIONS}")
    message(STATUS "Activated: ${CATKIN_SANITIZER}-sanitizer")
    add_compile_options(-fsanitize=${CATKIN_SANITIZER} -g)
  else()
    message(FATAL_ERROR "${CATKIN_SANITIZER} is not a valid sanitizer. Valid options are: [${SANITIZER_OPTIONS}]")
  endif()
endif()

################
## Clang tidy ##
################
# to run: catkin_make -DCATKIN_ENABLE_CLANG_TIDY=true
# build and devel folders have to be deleted before run
if(CATKIN_ENABLE_CLANG_TIDY)
  find_program(
    CLANG_TIDY_EXE
    NAMES "clang-tidy"
    DOC "Path to clang-tidy executable"
    )
  if(NOT CLANG_TIDY_EXE)
    message(FATAL_ERROR "clang-tidy not found.")
  else()
    message(STATUS "clang-tidy found: ${CLANG_TIDY_EXE}")
    set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE}")
  endif()
endif()

###########
## Build ##
###########

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${console_bridge_INCLUDE_DIRS}
)

set(${PROJECT_NAME}_sources
  src/scanner_v2.cpp
  src/laserscan.cpp
  src/monitoring_frame_msg.cpp
  src/start_request.cpp
  src/start_request_serialization.cpp
  src/stop_request_serialization.cpp
  src/scanner_configuration.cpp
  src/monitoring_frame_deserialization.cpp
  src/diagnostics.cpp
  src/scanner_reply_serialization_deserialization.cpp
)

set(${PROJECT_NAME}_node_sources
  src/psen_scan_driver.cpp
)

add_library(${PROJECT_NAME} ${${PROJECT_NAME}_sources})
target_link_libraries(${PROJECT_NAME}
  ${console_bridge_LIBRARIES}
  ${rosfmt_LIBRARIES}
)

add_executable(${PROJECT_NAME}_node ${${PROJECT_NAME}_node_sources})
target_link_libraries(${PROJECT_NAME}_node
  ${catkin_LIBRARIES}
  ${PROJECT_NAME}
)

#############
## Install ##
#############

install(DIRECTORY launch DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})
install(DIRECTORY config DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

install(DIRECTORY urdf/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/urdf)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install(TARGETS
  ${PROJECT_NAME}
  ${PROJECT_NAME}_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

############
##  Test  ##
############
if(CATKIN_ENABLE_TESTING)

  find_package(rostest REQUIRED)
  find_package(roslaunch REQUIRED)
  find_package(pilz_testutils REQUIRED)

  if(ENABLE_COVERAGE_TESTING)
    find_package(code_coverage REQUIRED)
    append_coverage_compiler_flags()
  endif()

  roslaunch_add_file_check(launch DEPENDENCIES ${PROJECT_NAME}_node)

  include_directories(include
    test/include
    ${pilz_testutils_INCLUDE_DIRS}
    ${catkin_INCLUDE_DIR}
  )

  ##################
  ##  Unit-Tests  ##
  ##################
  catkin_add_gtest(unittest_new_exceptions
    test/unit_tests/unittest_new_exceptions.cpp
  )
  target_link_libraries(unittest_new_exceptions
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_raw_processing
    test/unit_tests/unittest_raw_processing.cpp
  )
  target_link_libraries(unittest_raw_processing
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_start_request
    test/unit_tests/unittest_start_request.cpp
    src/start_request.cpp
    src/scanner_configuration.cpp
    src/start_request_serialization.cpp
  )
  target_link_libraries(unittest_start_request
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_stop_request
    test/unit_tests/unittest_stop_request.cpp
    src/stop_request_serialization.cpp
  )
  target_link_libraries(unittest_stop_request
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_scan_range
    test/unit_tests/unittest_scan_range.cpp
  )
  target_link_libraries(unittest_scan_range
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_scanner_configuration
    test/unit_tests/unittest_scanner_configuration.cpp
    src/scanner_configuration.cpp
  )
  target_link_libraries(unittest_scanner_configuration
    ${catkin_LIBRARIES}
  )

  catkin_add_gmock(unittest_tenth_of_degree
    test/unit_tests/unittest_tenth_of_degree.cpp
  )

  catkin_add_gmock(unittest_udp_client
    test/unit_tests/unittest_udp_client.cpp
  )
  target_link_libraries(unittest_udp_client
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_tenth_degree_conversion
    test/unit_tests/unittest_tenth_degree_conversion.cpp
  )
  target_link_libraries(unittest_tenth_degree_conversion
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_laserscan
    test/unit_tests/unittest_laserscan.cpp
    src/laserscan.cpp
  )
  target_link_libraries(unittest_laserscan
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_laserscan_conversions
    test/unit_tests/unittest_laserscan_conversions.cpp
    src/laserscan.cpp
    src/monitoring_frame_msg.cpp
    src/diagnostics.cpp
  )
  target_link_libraries(unittest_laserscan_conversions
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_laserscan_ros_conversions
    test/unit_tests/unittest_laserscan_ros_conversions.cpp
    src/laserscan.cpp
    src/monitoring_frame_msg.cpp
    src/diagnostics.cpp
  )
  target_link_libraries(unittest_laserscan_ros_conversions
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_scanner_reply_msg
    test/unit_tests/unittest_scanner_reply_msg.cpp
    src/scanner_reply_serialization_deserialization.cpp
  )
  target_link_libraries(unittest_scanner_reply_msg
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_monitoring_frame_msg
    test/unit_tests/unittest_monitoring_frame_msg.cpp
    src/monitoring_frame_msg.cpp
    src/diagnostics.cpp
    src/monitoring_frame_deserialization.cpp
  )
  target_link_libraries(unittest_monitoring_frame_msg
    ${catkin_LIBRARIES}
  )

  catkin_add_gtest(unittest_monitoring_frame_serialization_deserialization
    src/monitoring_frame_msg.cpp
    src/monitoring_frame_deserialization.cpp
    src/diagnostics.cpp
    test/unit_tests/unittest_monitoring_frame_serialization_deserialization.cpp
    test/src/monitoring_frame_serialization.cpp
  )
  target_link_libraries(unittest_monitoring_frame_serialization_deserialization
    ${catkin_LIBRARIES}
  )

  catkin_add_gmock(unittest_logging
    test/unit_tests/unittest_logging.cpp
  )
  target_link_libraries(unittest_logging
    ${catkin_LIBRARIES}
    ${console_bridge_LIBRARIES}
  )

  catkin_add_gmock(unittest_monitoring_frame_diagnostic_message
    src/diagnostics.cpp
    test/unit_tests/unittest_monitoring_frame_diagnostic_message.cpp
  )
  target_link_libraries(unittest_monitoring_frame_diagnostic_message
    ${catkin_LIBRARIES}
    ${console_bridge_LIBRARIES}
  )

  #########################
  ##  Integration-Tests  ##
  #########################
  catkin_add_gmock(integrationtest_udp_client
    test/integration_tests/integrationtest_udp_client.cpp
  )
  target_link_libraries(integrationtest_udp_client
    ${catkin_LIBRARIES}
    ${pilz_testutils_LIBRARIES}
  )

catkin_add_gmock(integrationtest_scanner_api
  test/integration_tests/integrationtest_scanner_api.cpp
  test/src/monitoring_frame_serialization.cpp
  src/scanner_v2.cpp
  src/laserscan.cpp
  src/monitoring_frame_msg.cpp
  src/monitoring_frame_deserialization.cpp
  src/scanner_configuration.cpp
  src/start_request.cpp
  src/stop_request_serialization.cpp
  src/diagnostics.cpp
  src/start_request_serialization.cpp
  src/scanner_reply_serialization_deserialization.cpp
)
target_link_libraries(integrationtest_scanner_api
  ${catkin_LIBRARIES}
  ${pilz_testutils_LIBRARIES}
  )

  add_rostest_gmock(integrationtest_ros_scanner_node
    test/integration_tests/integrationtest_ros_scanner_node.test
    test/integration_tests/integrationtest_ros_scanner_node.cpp
    src/laserscan.cpp
    src/scanner_configuration.cpp
    src/monitoring_frame_msg.cpp
    src/diagnostics.cpp
  )
  target_link_libraries(integrationtest_ros_scanner_node
    ${catkin_LIBRARIES}
    ${pilz_testutils_LIBRARIES}
  )

  add_rostest_gmock(unittest_ros_parameter_handler
      test/unit_tests/unittest_ros_parameter_handler.test
      test/unit_tests/unittest_ros_parameter_handler.cpp
  )
  target_link_libraries(unittest_ros_parameter_handler
    ${catkin_LIBRARIES}
    ${pilz_testutils_LIBRARIES}
  )

  ######################
  ##  Hardware-Tests  ##
  ######################

  # build this using catkin_make -DENABLE_HARDWARE_TESTING=ON
  if(ENABLE_HARDWARE_TESTING)
    find_package(rosbag REQUIRED)

    add_rostest_gtest(hwtest_scan_compare
        test/hw_tests/hwtest_scan_compare.test
        test/hw_tests/hwtest_scan_compare.cpp
    )
    target_link_libraries(hwtest_scan_compare
      ${catkin_LIBRARIES}
      ${pilz_testutils_LIBRARIES}
    )
  endif()


  # generate coverage report using CATKIN_MAKE:
  # catkin_make -DENABLE_COVERAGE_TESTING=ON -DCMAKE_BUILD_TYPE=Debug psen_scan_v2_coverage (adding -j1 recommended)
  #
  # generate coverage report using CATKIN:
  # catkin config --cmake-args -DENABLE_COVERAGE_TESTING=ON -DCMAKE_BUILD_TYPE=Debug
  # catkin build
  # catkin build psen_scan_v2 -v --no-deps --catkin-make-args psen_scan_v2_coverage
  if(ENABLE_COVERAGE_TESTING)
    set(COVERAGE_EXCLUDES "*/${PROJECT_NAME}/test*"
                          "*/${PROJECT_NAME}/src/psen_scan_driver.cpp")
    add_code_coverage(
      NAME ${PROJECT_NAME}_coverage
      DEPENDS tests
    )
  endif()
endif()

=== debian/changelog ===
ros-melodic-psen-scan-v2 (0.1.2-1stretch) stretch; urgency=high

  * Add Scanner ports in ScannerConfiguration
  * Switch branching model: Introduce main branch
  * Use github actions
  * Adds missing error bit
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 23 Nov 2020 23:00:00 -0000

ros-melodic-psen-scan-v2 (0.1.1-1stretch) stretch; urgency=high

  * Add intensity data to LaserScan
  * Print user message if dropped MonitoringFrames are detected
  * Print user message in case of timeout while waiting for MonitoringFrames
  * Adjust min and max scanner range. Fixes #70
  * Print diagnostic messages from PSENscan
  * Notify user about start retry
  * Add Continuous Acceptance Test
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 09 Nov 2020 23:00:00 -0000

ros-melodic-psen-scan-v2 (0.1.0-1stretch) stretch; urgency=high

  * Initial release for the support of PSENscan firmware >= 3.1.0
  * Start and stop the PSENscan monitoring function
  * Publish measurement data of each monitoring frame as a single ROS LaserScan message
  * Retry activation of the monitoring function on start reply timeout
  * Adding urdf for scanner and swapping Z axis of TF frame where scan is published to be sent in correct order
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 18 Oct 2020 22:00:00 -0000

=== debian/control ===
Source: ros-melodic-psen-scan-v2
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-code-coverage, ros-melodic-pilz-testutils, ros-melodic-rosbag, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-rosfmt, ros-melodic-roslaunch, ros-melodic-rostest, ros-melodic-rosunit, ros-melodic-sensor-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-psen-scan-v2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-robot-state-publisher, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-rosfmt, ros-melodic-roslaunch, ros-melodic-rviz, ros-melodic-sensor-msgs, ros-melodic-xacro
Description: ROS support for the Pilz laser scanner

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-psen-scan-v2//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-psen-scan-v2 0.10.2

=== standalone/CMakeLists.txt ===
# Copyright (c) 2020-2021 Pilz GmbH & Co. KG
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.0.2)
project(psen_scan_v2_standalone)

add_compile_options(-std=c++14)
if (UNIX)
  add_compile_options(-Wall)
  add_compile_options(-Wextra)
  add_compile_options(-Wno-unused-parameter)
  add_compile_options(-Werror)
endif (UNIX)
if (WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4") # Turn of warnings
  add_definitions(-DNOMINMAX)
endif (WIN32)

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

## System dependencies are found with CMake's conventions
find_package(Boost 1.69) ## Boost::system is header-only since 1.69
if(Boost_FOUND)
  add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY -DBOOST_DATE_TIME_NO_LIB -DBOOST_REGEX_NO_LIB -DBOOST_SYSTEM_NO_LIB)
else()
  find_package(Boost REQUIRED COMPONENTS system)
endif()
find_package(console_bridge REQUIRED)
find_package(fmt REQUIRED)

###########
## Build ##
###########

include_directories(
  include
  ${console_bridge_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
)

set(${PROJECT_NAME}_sources
  src/scanner_v2.cpp
  src/io_state.cpp
  src/laserscan.cpp
  src/data_conversion_layer/monitoring_frame_msg.cpp
  src/data_conversion_layer/start_request.cpp
  src/data_conversion_layer/start_request_serialization.cpp
  src/data_conversion_layer/stop_request_serialization.cpp
  src/data_conversion_layer/monitoring_frame_deserialization.cpp
  src/data_conversion_layer/diagnostics.cpp
  src/data_conversion_layer/scanner_reply_serialization_deserialization.cpp
)

add_library(${PROJECT_NAME} ${${PROJECT_NAME}_sources})

target_link_libraries(${PROJECT_NAME}
  ${Boost_LIBRARIES}
  ${console_bridge_LIBRARIES}
  fmt::fmt
)
target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")

add_executable(${PROJECT_NAME}_app main.cpp)
target_link_libraries(${PROJECT_NAME}_app
  ${PROJECT_NAME}
)

###########
## Tests ##
###########
if (BUILD_TESTING)

include(CTest)

# The standalone is included  with add_subdirectory from the top-level ROS CMakeLists.txt
# However the tests are build separately in the top-level and thus should be ignored here.
# If you don't know what ROS is, simply ignore this line.
if(NOT DEFINED catkin_FOUND)

# Download + Install gtest (see https://github.com/google/googletest/blob/master/googletest/README.md)
configure_file(CMakeLists.txt.in googletest-download/CMakeLists.txt)
execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if(result)
  message(FATAL_ERROR "CMake step for googletest failed: ${result}")
endif()
execute_process(COMMAND ${CMAKE_COMMAND} --build .
  RESULT_VARIABLE result
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/googletest-download )
if(result)
  message(FATAL_ERROR "Build step for googletest failed: ${result}")
endif()

set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                 ${CMAKE_CURRENT_BINARY_DIR}/googletest-build
                 EXCLUDE_FROM_ALL)

if (CMAKE_VERSION VERSION_LESS 2.8.11)
  include_directories("${gtest_SOURCE_DIR}/include")
endif()

include_directories(
  test/include
  ${GTEST_INCLUDE_DIRS}
)

ADD_EXECUTABLE(unittest_laserscan_conversions test/unit_tests/data_conversion_layer/unittest_laserscan_conversions.cpp)

TARGET_LINK_LIBRARIES(unittest_laserscan_conversions
    ${PROJECT_NAME}
    gtest gmock
)

ADD_TEST(NAME unittest_laserscan_conversions
         COMMAND unittest_laserscan_conversions)

ADD_EXECUTABLE(unittest_laserscan test/unit_tests/api/unittest_laserscan.cpp)

TARGET_LINK_LIBRARIES(unittest_laserscan
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_laserscan
         COMMAND unittest_laserscan)

ADD_EXECUTABLE(unittest_pin_state
               test/unit_tests/api/unittest_pin_state.cpp
               src/io_state.cpp)

TARGET_LINK_LIBRARIES(unittest_pin_state
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_pin_state
         COMMAND unittest_pin_state)

ADD_EXECUTABLE(unittest_io_state
               test/unit_tests/api/unittest_io_state.cpp
               src/io_state.cpp)

TARGET_LINK_LIBRARIES(unittest_io_state
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_io_state
         COMMAND unittest_io_state)

ADD_EXECUTABLE(unittest_io_state_conversions
               test/unit_tests/data_conversion_layer/unittest_io_state_conversions.cpp
               src/io_state.cpp)

TARGET_LINK_LIBRARIES(unittest_io_state_conversions
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_io_state_conversions
         COMMAND unittest_io_state_conversions)

ADD_EXECUTABLE(unittest_io_pin_data test/unit_tests/data_conversion_layer/unittest_io_pin_data.cpp)

TARGET_LINK_LIBRARIES(unittest_io_pin_data
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_io_pin_data
         COMMAND unittest_io_pin_data)

ADD_EXECUTABLE(unittest_logging test/unit_tests/util/unittest_logging.cpp)

TARGET_LINK_LIBRARIES(unittest_logging
    ${PROJECT_NAME}
    gtest gmock
)

ADD_TEST(NAME unittest_logging
         COMMAND unittest_logging)


ADD_EXECUTABLE(unittest_monitoring_frame_diagnostic_message test/unit_tests/data_conversion_layer/unittest_monitoring_frame_diagnostic_message.cpp)

TARGET_LINK_LIBRARIES(unittest_monitoring_frame_diagnostic_message
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_monitoring_frame_diagnostic_message
         COMMAND unittest_monitoring_frame_diagnostic_message)

ADD_EXECUTABLE(unittest_monitoring_frame_msg test/unit_tests/data_conversion_layer/unittest_monitoring_frame_msg.cpp)

TARGET_LINK_LIBRARIES(unittest_monitoring_frame_msg
    ${PROJECT_NAME}
    gtest gmock
)

ADD_TEST(NAME unittest_monitoring_frame_msg
         COMMAND unittest_monitoring_frame_msg)

ADD_EXECUTABLE(unittest_monitoring_frame_msg_stamped
               test/unit_tests/data_conversion_layer/unittest_monitoring_frame_msg_stamped.cpp)

TARGET_LINK_LIBRARIES(unittest_monitoring_frame_msg_stamped
    ${PROJECT_NAME}
    gtest gmock
)

ADD_TEST(NAME unittest_monitoring_frame_msg_stamped
         COMMAND unittest_monitoring_frame_msg_stamped)

ADD_EXECUTABLE(unittest_monitoring_frame_serialization_deserialization
               test/unit_tests/data_conversion_layer/unittest_monitoring_frame_serialization_deserialization.cpp
               test/src/data_conversion_layer/monitoring_frame_serialization.cpp)

TARGET_LINK_LIBRARIES(unittest_monitoring_frame_serialization_deserialization
    ${PROJECT_NAME}
    gtest gmock
)

ADD_TEST(NAME unittest_monitoring_frame_serialization_deserialization
         COMMAND unittest_monitoring_frame_serialization_deserialization)


ADD_EXECUTABLE(unittest_raw_processing test/unit_tests/data_conversion_layer/unittest_raw_processing.cpp)

TARGET_LINK_LIBRARIES(unittest_raw_processing
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_raw_processing
         COMMAND unittest_raw_processing)


ADD_EXECUTABLE(unittest_scan_range test/unit_tests/util/unittest_scan_range.cpp)

TARGET_LINK_LIBRARIES(unittest_scan_range
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_scan_range
         COMMAND unittest_scan_range)


ADD_EXECUTABLE(unittest_scanner_configuration test/unit_tests/configuration/unittest_scanner_configuration.cpp)

TARGET_LINK_LIBRARIES(unittest_scanner_configuration
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_scanner_configuration
         COMMAND unittest_scanner_configuration)


ADD_EXECUTABLE(unittest_scanner_reply_msg test/unit_tests/data_conversion_layer/unittest_scanner_reply_msg.cpp)

TARGET_LINK_LIBRARIES(unittest_scanner_reply_msg
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_scanner_reply_msg
         COMMAND unittest_scanner_reply_msg)


ADD_EXECUTABLE(unittest_start_request test/unit_tests/data_conversion_layer/unittest_start_request.cpp)

TARGET_LINK_LIBRARIES(unittest_start_request
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_start_request
         COMMAND unittest_start_request)


ADD_EXECUTABLE(unittest_stop_request test/unit_tests/data_conversion_layer/unittest_stop_request.cpp)

TARGET_LINK_LIBRARIES(unittest_stop_request
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_stop_request
        COMMAND unittest_stop_request)


ADD_EXECUTABLE(unittest_tenth_degree_conversion test/unit_tests/data_conversion_layer/unittest_tenth_degree_conversion.cpp)

TARGET_LINK_LIBRARIES(unittest_tenth_degree_conversion
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_tenth_degree_conversion
        COMMAND unittest_tenth_degree_conversion)


ADD_EXECUTABLE(unittest_tenth_of_degree test/unit_tests/util/unittest_tenth_of_degree.cpp)

TARGET_LINK_LIBRARIES(unittest_tenth_of_degree
    ${PROJECT_NAME}
    gtest
)

ADD_TEST(NAME unittest_tenth_of_degree
        COMMAND unittest_tenth_of_degree)


ADD_EXECUTABLE(unittest_udp_client test/unit_tests/communication_layer/unittest_udp_client.cpp)

TARGET_LINK_LIBRARIES(unittest_udp_client
    ${PROJECT_NAME}
    gtest gmock
)

ADD_TEST(NAME unittest_udp_client
        COMMAND unittest_udp_client)


add_executable(integrationtest_scanner_api
        test/integration_tests/api/integrationtest_scanner_api.cpp
        test/src/communication_layer/mock_udp_server.cpp
        test/src/communication_layer/scanner_mock.cpp
        test/src/data_conversion_layer/monitoring_frame_serialization.cpp)

target_link_libraries(integrationtest_scanner_api
    ${PROJECT_NAME}
    gtest gmock
)

add_test(NAME integrationtest_scanner_api
        COMMAND integrationtest_scanner_api)


add_executable(integrationtest_udp_client
        test/integration_tests/communication_layer/integrationtest_udp_client.cpp
        test/src/communication_layer/mock_udp_server.cpp)

target_link_libraries(integrationtest_udp_client
    ${PROJECT_NAME}
    gtest gmock
)

add_test(NAME integrationtest_udp_client
        COMMAND integrationtest_udp_client)

endif ()
endif ()

=== debian/changelog ===
ros-melodic-psen-scan-v2 (0.10.2-1bionic) bionic; urgency=high

  * Remove zoneset bits from IOState.input field since its redundant to the active_zoneset field (#311)
  * Inform about missing configuration confirmation
  * Ignore changes of unused IOs. Fix #321
  * Fill "io_states" vector as received instead of order by theta to avoid flickering. Fix #320
  * Fixed bug of multiple zonesets being visible #328
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 02 Nov 2022 23:00:00 -0000

ros-melodic-psen-scan-v2 (0.10.1-1bionic) bionic; urgency=high

  * Separate 'PinState' formating from 'formatRange' (#313)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 23 Jan 2022 23:00:00 -0000

ros-melodic-psen-scan-v2 (0.10.0-1bionic) bionic; urgency=high

  * Change to new versioning method for ROS1 (0.10.0+) and ROS2 (0.20.0+).
  * Deprecate get/set methods with 'get/set' prefix in favour of methods without the prefix(#298)
  * ADD IO states to LaserScan and publish them at ~/io_state (#281)
  * Renaming Slave to Subscriber (#303)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 19 Jan 2022 23:00:00 -0000

ros-melodic-psen-scan-v2 (0.3.4-1bionic) bionic; urgency=high

  * Prevent error when diagnostics are disabled. Fix #294
  * Set exception in stop-future
  * Apply clang-tidy fixes to header-files. Fix #277
  * Remove latched flag from active zoneset topic
  * API change: convenience usage of ScannerConfiguration
  * Remove unrelated parameter DEFAULT_X_AXIS_ROTATION from standalone
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 19 Dec 2021 23:00:00 -0000

ros-melodic-psen-scan-v2 (0.3.3-1bionic) bionic; urgency=high

  * Introduce error state and set exception in start-future
  * Remove dependency on pilz_testutils
  * Always build hardware tests
  * Internal refactorings
  * Importing the config xml-file and publishing the zoneconfiguration
  * Add active zoneset to LaserScan
  * Publish active zoneset id to ~/active_zoneset
  * Add active zoneset visualization in rviz
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 09 Nov 2021 23:00:00 -0000

ros-melodic-psen-scan-v2 (0.3.2-1bionic) bionic; urgency=high

  * Improve performance of standalone part
    
    Introduce RawDataPtr
    
    Write to std::stringstream instead of constructing from std::string
    
    Pass by reference wherever possible
  * Make release build the default
  * Calculate timestamp as the time of the first ray (udp communication time is neglected)
  * API: Add timestamp (nanoseconds since epoch) to LaserScan
  * API: Add scan counter to LaserScan
  * API: remove LaserScan equality operator
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Wed, 15 Sep 2021 22:00:00 -0000

ros-melodic-psen-scan-v2 (0.3.1-1bionic) bionic; urgency=high

  * Rename urdf links
  * Apply tf prefix equals node name
  * API change: rename launch-file argument prefix->tf_prefix
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Tue, 20 Jul 2021 22:00:00 -0000

ros-melodic-psen-scan-v2 (0.3.0-1bionic) bionic; urgency=high

  * Set prefix for node name (same value as for tf frames)
  * Introduce bringup.launch for starting only the scanner node
  * Omit closing the data client before destruction. Fixes #212
  * Distance value at angle_end is now included in the scan range
  * Default scan range changed to [-137.4..137.4]deg at 0.1 deg resolution
  * Add options for modifying resolution and enabling intensities
  * Add launchfile option for disabling rviz at startup (default: enable)
  * Handle the infinity codes from the scanner correctly
  * Inform user about current scan range
  * Fix wrong behavior when angle_start and angle_end are equal
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Mon, 28 Jun 2021 22:00:00 -0000

ros-melodic-psen-scan-v2 (0.2.1-1bionic) bionic; urgency=high

  * Fix issues with smaller angle ranges than default range (#183 <https://github.com/PilzDE/psen_scan_v2/issues/183>)
  * Add action for pull request todos (#184 <https://github.com/PilzDE/psen_scan_v2/issues/184>)
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 18 Apr 2021 22:00:00 -0000

ros-melodic-psen-scan-v2 (0.2.0-1bionic) bionic; urgency=high

  * Combine multiple monitoring frames into one scan (#173 <https://github.com/PilzDE/psen_scan_v2/issues/173>)
  * Contributors: Pilz GmbH and Co. KG
  * API change: Driver waits for scan round to complete before sending measurement data by default
  * Introducing new parameter fragmented_scans to switch back to faster fragmented laser_scan messages
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 04 Apr 2021 22:00:00 -0000

ros-melodic-psen-scan-v2 (0.1.6-1bionic) bionic; urgency=high

  * Separate ROS and standalone CMakeLists: Closes #169
  * Minor restructuring. Closes #175
  * Contributors: Pilz GmbH and Co. KG

 -- Alexander Gutenkunst <a.gutenkunst@pilz.de>  Sun, 21 Mar 2021 23:00:00 -0000

ros-melodic-psen-scan-v2 (0.1.5-1bionic) bionic; urgency=high

  * Make specifying host ip optional
  * Reorder Readme sections
  * API change: A scan is published only if it contains measurement data
  * Make tests build in standalone with or without ROS installed
  * Document key components in a meaningful expressive way
  * Enable building the standalone lib using MSVC
  * Enable separate building of cpp-lib; extract sources into subproject psen_scan_v2_standalone
  * Renames ScanRange and DefaultScanRange to improve usability
  * Improve namespace hierarchy and move files to respective subfolders
  * Use defaults ports in ScannerConfiguration
  * Contributors: Pilz GmbH and Co. KG



=== debian/control ===
Source: ros-melodic-psen-scan-v2
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), libfmt-dev, libtinyxml2-dev, ros-melodic-catkin, ros-melodic-cmake-modules, ros-melodic-code-coverage <!nocheck>, ros-melodic-geometry-msgs, ros-melodic-message-generation, ros-melodic-rosbag <!nocheck>, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-roslaunch <!nocheck>, ros-melodic-rostest <!nocheck>, ros-melodic-rosunit <!nocheck>, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-psen-scan-v2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libfmt-dev, libtinyxml2-dev, ros-melodic-geometry-msgs, ros-melodic-message-runtime, ros-melodic-robot-state-publisher, ros-melodic-rosconsole-bridge, ros-melodic-roscpp, ros-melodic-roslaunch, ros-melodic-rviz, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-visualization-msgs, ros-melodic-xacro
Description: ROS support for the Pilz laser scanner

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
